use serde::Deserialize;
use anyhow::Result;
use serde_json;

#[derive(Debug,Deserialize)]
pub struct Charger {
    pub id: String,
    pub channel_id: String,
    pub owners: Vec<String>,
}

#[derive(Debug,Deserialize)]
pub struct Mattermost {
    pub base: String,
    pub token: String,
}

#[derive(Debug,Deserialize)]
pub struct Prometheus {
    pub base: String
}

#[derive(Debug,Deserialize)]
pub struct Config {
    pub easee_token_path: String,
    pub prometheus: Prometheus,
    pub mattermost: Mattermost,
    pub chargers: Vec<Charger>,
}

#[derive(Debug,Deserialize)]
pub struct Regulator {
    power_bias_watts: f64,
    monophase_volts: f64,
}

pub fn load_config(path: &str) -> Result<Config> {
    Ok(serde_json::from_str(&std::fs::read_to_string(path)?)?)
}